; Programa: Ejemplo de agentes basicos combinatorios
;           que juegan al mastermind
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             CSI - ULL
; Prctica: 3a (sistemas de produccin)
; Profesor: Patricio Garca
; Fecha: 11/5/2001
; Comentarios:
;              Hace uso del package mastmind, shell y q_search
;              (load "mastmind")(load "shell")(load "q_search")
;
; ToDo list:

(use-package "mastmind")

; Agente combinatorio (sin sistema de prdoduccion)

(defun agente-combinatorio ()
  "Agente que juega generando todas las posibles combinaciones del mastermind"
  (agente-combinatorio-r nil))

; Recursivamente va obteniendo los posibles codigos usando mestmind
(defun agente-combinatorio-r (codigo-in)
  (if (= (length codigo-in) *num-elem-mm*)
      (let ((resultado (test-master-mind codigo-in)))
	(when (= (first resultado) *num-elem-mm*)
	  codigo-in))
      (do ((col 0 (1+ col))
	   (solucion nil))
	  ((or solucion (= col *num-digitos-mm*)) solucion)
	(when (not (member col codigo-in))
	    (setf solucion (agente-combinatorio-r (cons col codigo-in)))))))
     

; Para pruebas:
;
; (load "mastmind")(load "agente-comb")
; (inic-master-mind #'agente-combinatorio :verb t :tipo '(3 4))
; (inic-master-mind #'agente-combinatorio :verb t :tipo '(3 4) :num 20)


; Agente combinatorio usando un Sistema de Produccion

; Generacion de Reglas usando shell
(defmacro gen-regla-add-color (col)
  `(regla 
    ; Precondicion
    `(lambda (codigo-in)
      (and (< (length codigo-in) *num-elem-mm*)
	   (not (member ,col codigo-in))))
    ; Accion
    `(lambda (codigo-in)
      (cons ,col (copy-list codigo-in)))))

(defun genera-reglas ()
  (setf *sistema* nil)
  (dotimes (col *num-digitos-mm* nil)
    (gen-regla-add-color col)))

;Funcion estado de inicio
(defun inicio ()
  nil)

;Fucnion Objetivo
(defun objetivo (codigo-in)
  (and (= (length codigo-in) *num-elem-mm*)
       (not (member codigo-in probados :test #'equal))))

;Llamada a bsqueda en profundidad usando q_search y shell
(defun bp ()
  (generic-search (inicio) #'objetivo #'hijos
		  :display-fn #'not
		  :merge-fn #'(lambda (new-states)
				(nconc new-states *search-queue*))
		  :dequeue-fn #'(lambda () (pop *search-queue*))))



; Agente ppd usando mestmind

(defvar probados nil "Lista de codigos ya testeados")

(defun agente-comb-sp ()
  (genera-reglas)
  (setf probados nil)
  (do ((a-probar (bp) (bp)))
      ((= (first (test-master-mind a-probar)) *num-elem-mm*) a-probar)
    (push a-probar probados)))

; Para Pruebas:
;
; (load "mastmind")(load "shell")(load "q_search")(load "agente-comb")
; (inic-master-mind #'agente-comb-sp :verb t :tipo '(3 4) :num 1)
; (inic-master-mind #'agente-comb-sp :verb t :tipo '(3 4) :num 20)


